/*
 * @(#)Tool.java	Jan-2008
 *
 * Murat iNAN, muratsivas76@gmail.com
 */
package com.javamar.arac;

import java.awt.*;

import javax.swing.*;
import javax.swing.text.*;


/**
 * This class holds character constants
 *
 * @author Murat iNAN, muratsivas76@gmail.com
 * <p>
 * <a href="http://www.dilmerkezi.net">
 * Improve Java Programs
 * </a>
 */
public 	class 		Tool
	extends		Object
	implements 	java.io.Serializable
{
    
    /** Russian mode*/
    public static boolean russian = false;
    
    /** Cyrillic Characters*/
    private static final String cyrillicstr [] = 
    {
	"\u0410", //A
	"\u0411",//B~
	"\u0412", //V
	"\u0413", //G
	"\u0414", //D
	"\u0415", //YE
	"\u0401", //Y~~
	"\u0416", //J
	"\u0417", //Z
	"\u0418", //i~
	"\u0419", //Y
	"\u041A", //K
	"\u041B", //L
	"\u041C", //M
	"\u041D", //N
	"\u041E", //O
	"\u041F", //P
	"\u0420", //R
	"\u0421", //S
	"\u0422", //T
	"\u0423", //U
	"\u0424", //F
	"\u0425", //X
	"\u0426", //TS
	"\u0427", //CH
	"\u0428", //SH
	"\u0429", //SH~
	"\u042C", //YI
	"\u042B", //I
	"\u042A", //SI
	"\u042D", //E
	"\u042E", //YU
	"\u042F", //YA
	/**/
	"\u0430", //a
	"\u0431", //b~
	"\u0432", //v
	"\u0433", //g
	"\u0434", //d
	"\u0435", //ye
	"\u0451", //y~~
	"\u0436", //j
	"\u0437", //z
	"\u0438", //i
	"\u0439", //y
	"\u043A", //k
	"\u043B", //l
	"\u043C", //m
	"\u043D", //n
	"\u043E", //o
	"\u043F", //p
	"\u0440", //r
	"\u0441", //s
	"\u0442", //t
	"\u0443", //u
	"\u0444", //f
	"\u0445", //x
	"\u0446", //ts
	"\u0447", //ch
	"\u0448", //sh
	"\u0449", //sh~
	"\u044C", //yi
	"\u044B", //kI
	"\u044A", //si
	"\u044D", //e
	"\u044E", //yu
	"\u044F" //ya    
    };
    
    /** Cyrillic Characters*/    
    private static final char [] cyrillicchr =
    {
	'\u0410', //A
	'\u0411', //B~
	'\u0412', //V
	'\u0413', //G
	'\u0414', //D
	'\u0415', //YE
	'\u0401', //Y~~
	'\u0416', //J
	'\u0417', //Z
	'\u0418', //i~
	'\u0419', //Y
	'\u041A', //K
	'\u041B', //L
	'\u041C', //M
	'\u041D', //N
	'\u041E', //O
	'\u041F', //P
	'\u042C', //R
	'\u0421', //S
	'\u0422', //T
	'\u0423', //U
	'\u0424', //F
	'\u0425', //X
	'\u0426', //TS
	'\u0427', //CH
	'\u0428', //SH
	'\u0429', //SH~
	'\u042C', //YI
	'\u042B', //I
	'\u042A', //SI
	'\u042D', //E
	'\u042E', //YU
	'\u042F', //YA    
	/**/
	'\u0430', //a
	'\u0431', //b~
	'\u0432', //v
	'\u0433', //g
	'\u0434', //d
	'\u0435', //ye
	'\u0451', //y~~
	'\u0436', //j
	'\u0437', //z
	'\u0438', //i
	'\u0439', //y
	'\u043A', //k
	'\u043B', //l
	'\u043C', //m
	'\u043D', //n
	'\u043E', //o
	'\u043F', //p
	'\u0440', //r
	'\u0441', //s
	'\u0442', //t
	'\u0443', //u
	'\u0444', //f
	'\u0445', //x
	'\u0446', //ts
	'\u0447', //ch
	'\u0448', //sh
	'\u0449', //sh~
	'\u044C', //yi
	'\u044B', //kI
	'\u044A', //si
	'\u044D', //e
	'\u044E', //yu
	'\u044F', //ya    
    };
    
    /** Singleton constructor*/	
    private Tool ()
    {}    
    
    /**
     * @return Cyrillic characters
     */
    public static final String [] getCyrillicstr ()
    {
	return cyrillicstr;
    }

    /**
     * @return Cyrillic characters
     */
    public static final char [] getCyrillicchr ()
    {
	return cyrillicchr;
    }

    /**
     * Adjust font name
     *
     * @param c Source text component
     * @return A new named font
     */
    public final static Font getFamiliedFont (JTextComponent c)
    {
	return getFamiliedFont_pri (c);
    }
    
    /**
     * Adjust size of the font
     *
     * @param c Source text component
     * @return New sized font
     */
    public final static Font getSizedFont (JTextComponent c)
    {
	return getSizedFont_pri (c);
    }    
    
    /**
     * Adjust style of the font
     *
     * @param c Source text component
     * @return A new styled font
     */
    public final static Font getStyledFont (JTextComponent c)
    {
	return getStyledFont_pri (c);
    }    
    
    /** Graphics environment*/
    private static final GraphicsEnvironment genv = 
	GraphicsEnvironment.getLocalGraphicsEnvironment ();

    /** All font names in this computer*/
    private static final String [] fontNames = genv.getAvailableFontFamilyNames ();

    /**
     * Adjust font name
     *
     * @param c Source text component
     * @return A new named font
     */
    private final static Font getFamiliedFont_pri (JTextComponent c)
    {
	Font f = c.getFont ();
	int stil = f.getStyle ();
	int size = f.getSize ();
	Object obj = null;
	try
	{
	    obj = JOptionPane.showInputDialog 
	    (
		c,
		"Select text font family",
		"Font Families",
		JOptionPane.QUESTION_MESSAGE,
		null,
		fontNames,
		fontNames [0]
	    );
	}
	catch (Exception ex)
	{
	    obj = null;
	}
	
	if (obj == null)
	{
	    return f;
	}
	
	f = new Font (obj.toString (), stil, size);	
	return f;
    }
    
    /**
     * Adjust size of the font
     *
     * @param c Source text component
     * @return New sized font
     */
    private final static Font getSizedFont_pri (JTextComponent c)
    {
	Font f = c.getFont ();
	String name = f.getFamily ();
	int stil = f.getStyle ();
	int size = f.getSize ();
	String str = null;
	try
	{
	    str = JOptionPane.showInputDialog (c, "Enter a font size value");
	}
	catch (Exception ex)
	{
	    return f;
	}
	
	if (str == null)
	{
	    return f;
	}
	
	try
	{
	    size = Integer.parseInt (str);
	}
	catch (Exception ex)
	{
	    return f;
	}
	
	f = new Font (name, stil, size);
	return f;
    }
    
    private static final String [] styles = 
    { 
        "Plain", "Bold", "Italic", "Bold+Italic"
    };
    
    /**
     * Adjust style of the font
     *
     * @param c Source text component
     * @return A new styled font
     */
    private final static Font getStyledFont_pri (JTextComponent c)
    {
	Font f = c.getFont ();
	String name = f.getFamily ();
	int size = f.getSize ();
	Object obj = null;
	try
	{
	    obj = JOptionPane.showInputDialog 
	    (
		c,
		"Select text font family",
		"Font Families",
		JOptionPane.QUESTION_MESSAGE,
		null,
		styles,
		styles [0]
	    );
	}
	catch (Exception ex)
	{
	    obj = null;
	}
	
	if (obj == null)
	{
	    return f;
	}
	
	String str = obj.toString ();
	if (str.indexOf ("+") != -1)
	{
	    f = new Font (name, Font.BOLD+Font.ITALIC, size);
	    return f;
	}
	
	if (str.equals ("Bold"))
	{
	    f = new Font (name, Font.BOLD, size);
	}
	else if (str.equals ("Italic"))
	{
	    f = new Font (name, Font.ITALIC, size);	
	}
	else if (str.equals ("Plain"))
	{
	    f = new Font (name, Font.PLAIN, size);	
	}
	
	return f;
    }

    /**
     * Provide a class description
     *
     * @return A short class description
     */
    public String toString ()
    {
	return "Character constants for latin & cyrillic languages";
    }
    
}
/***********/

